/*******************************************************************
*h*
*   Name:	
*
*   		dp83820_intr.c
*
*   Description :	
*
*   		This file contains the interrupt handler.
* 
*   History:  
*h*
*********************************************************************/

#include "nsm.h"
#include "hsm.h"

/*********************************************************************
 * Name : dp83820_intr
 *
 * Description :
 *
 *	This is the interrupt handler of the driver
 *
 * Arguments :
 *
 *	pv  void pointer which points to NsmContext
 *
 * Return Values
 *
 * 	None.
 *
 *********************************************************************/

VOID
dp83820_intr(void *pv)
{
	NsmContext	*pNsm;
	struct ifnet		*ifp;
	AdapterContext *pAdapter;

	pNsm = (NsmContext *)pv;
	pAdapter = &(pNsm->Adapter);

	ifp = &pNsm->arpcom.ac_if;

	/* Supress unwanted interrupts */
	if (!(ifp->if_flags & IFF_UP)) {
		dp83820_stop(pNsm);
		return;
	}

	HsmIsr(pAdapter);

	return;
}
