/******************************************************************************
*h*
*   Name:		
*   		nsmsol.c
*
*   Description:	
*   		NSM code for NSC's Gigabit NIC DP83820 on Solaris 2.7.
*  
*   Author:  
* 
*   History:  
*			Version 1 : April 8 2000.		
*h*
******************************************************************************/

/*
 *  dlsdmult() -- disabled.
 */

/*** Include files ***/
#include <nsm.h>

/*** External Global Vars ***/


/*** External Global Func ***/

/*** Local Constant Definitions ***/

static char ident[]= "National Semiconductor's Gigabit Ethernet Driver DP83820";


/*** Local Typedefs ***/

/*** Local Function Prototypes ***/

INT			_init(VOID);
INT			_fini( VOID );
INT			_info(struct modinfo *modinfop);
STATIC INT 	dp83820_attach(dev_info_t *devinfo, ddi_attach_cmd_t cmd);
STATIC INT 	dp83820_detach(dev_info_t *devinfo, ddi_detach_cmd_t cmd);
INT 		ReadPCI_Config(AdapterContext	*pAdapterContext);
INT 		FragmentMessage(PktInfo *pkt, mblk_t *mp);
/*
VOID 		NsmRxCompleted(caddr_t arg);
*/
VOID 		FreeRtn(NsmContext *arg);
/*
VOID 		NsmMarkRcbFree(HsmRCB *pRcb) ;
VOID 		NsmFreeContiguous(NsmContext *pNsm, AddrStruct *pAddr);
*/
STATIC INT 	dp83820_power(dev_info_t *devinfo, INT component, INT level);
STATIC INT 	dp83820_reset(gld_mac_info_t	*macinfo);
STATIC INT 	dp83820_start_board(gld_mac_info_t	*macinfo);
STATIC INT 	dp83820_stop_board(gld_mac_info_t	*macinfo);
STATIC INT  dp83820_saddr(gld_mac_info_t *macinfo, UCHAR *macaddr);
STATIC INT 	dp83820_dlsdmult(gld_mac_info_t	*mainfo, 
			struct ether_addr *macaddr, int op);
STATIC INT 	dp83820_prom(gld_mac_info_t	*macinfo, int on);
INT 		dp83820_send(gld_mac_info_t	*macinfo, mblk_t	*mp);
STATIC INT 	dp83820_gstat(gld_mac_info_t	*macinfo, 
			struct gld_stats	*stat);
STATIC INT	dp83820_ioctl(gld_mac_info_t *mac, queue_t	*q, mblk_t	*mp);
STATIC UINT	dp83820_intr(gld_mac_info_t	*macinfo);

/*** Local Data Definitions ***/

/*	KERNEL configurations. 	*/

CHAR	_depends_on[] = "misc/gld";

/* 
 * Soft State Structure.
 */
typedef struct softstate_struct { 
	dev_info_t		*dip;		/* Pointer to devinfo structure. */
	gld_mac_info_t	*macinfo;	/* Pointer to GLD macinfo structure. */
	AdapterContext	*pAdapter;	/* Pointer to adapter context. */
	NsmContext		*pNsm;	/* Pointer to adapter context. */
	frtn_t			*Free_rtn;
} dp83820_softstate_t;

/* 
 * Module information structure
 */
static struct module_info	dp83820_modinfo = { 
	DP83820_MODULE_ID, 	/* mi_idnum : Module ID */	
	"dp",			/* mi_idname : Module Name */
	DP83820_MINPKT,		/* mi_minpsz : Minimum Packet Size. */
	DP83820_MAXPKT,		/* mi_maxpsz : Maximum Packet Size. */
	DP83820_HIWAT,		/* mi_hiwat : High Water Mark. */
	DP83820_LOWAT,		/* mi_lowat : Low Water Mark. */
};

/* 
 * 	Structures for read and write queues
 */
static struct qinit dp83820_str_rinit = {
	NULL,				/* qi_putp	*/
	gld_rsrv,			/* qi_srvp	*/
	gld_open,			/* qi_qopen	*/
	gld_close,			/* qi_qopen	*/
	NULL,				/* qi_qadmin	*/
	&dp83820_modinfo,	/* qi_minfo	*/
	NULL			/* qi_mstat	*/
};

static struct qinit dp83820_str_winit = {
	gld_wput,		/* qi_putp	*/
	gld_wsrv,		/* qi_srvp	*/
	NULL,    		/* qi_qopen	*/
	NULL,     		/* qi_qclose	*/
	NULL,			/* qi_qadmin	*/
	&dp83820_modinfo,		/* qi_minfo	*/
	NULL			/* qi_mstat	*/
	
};

/* 
 * 	Streamtab structure
 */
static struct streamtab dp83820_streaminfo = {
	&dp83820_str_rinit,	/* rdinit */
	&dp83820_str_winit,	/* wrinit */
	NULL,			/* muxrinit */
	NULL			/* muxwinit */
};

/*
 * 	cb_ops structure which has function pointers to the driver's device access
 *	entry  points (for eg. open, close, read, write, ..etc). The entry points
 *	listed here are for both character and block device operations.
 */

static struct cb_ops dp83820_cb_ops = { 
	nodev,			/* cb_open		*/
	nodev,			/* cb_close	*/
	nodev,			/* cb_strategy	*/
	nodev,			/* cb_print		*/
	nodev,			/* cb_dump		*/
	nodev,			/* cb_read		*/
	nodev,			/* cb_write		*/
	nodev,			/* cb_ioctl		*/
	nodev,			/* cb_devmap	*/
	nodev,			/* cb_mmap		*/
	nodev,			/* cb_segmap	*/
	nochpoll,		/* cb_chpoll	*/	
	ddi_prop_op,	/* cb_prop_op	*/	
	&dp83820_streaminfo,	/* cb_str : Pointer to streamtab structure	*/
	D_NEW | D_MP,	/* cb_flag	*/
	CB_REV,			/* cb_rev 	*/
	nodev,			/* cb_aread */
	nodev			/* cb_awrite */
};

/*
 * 	dev_ops structure which initializes the function pointers of the 
 *	driver auto-configuration routines. This allows the kernel to find the 
 *	autoconfiguration entry points of the driver. (eg. attach, detach, getinfo..)
 */

static struct dev_ops dp83820_dev_ops = {
    DEVO_REV,			/* rev */
    0,					/* refcnt */
    gld_getinfo,		/* getinfo (can be devinfo also) */
    nulldev,			/* identify */
    nulldev,			/* probe */
    dp83820_attach,		/* attach */
    dp83820_detach,		/* detach */
    nodev,				/* reset */
    &dp83820_cb_ops,	/* cb_ops */
    (struct bus_ops *) NULL,	/* bus_ops */
    nodev       /* power */
};

 
/*
 * 	modldrv and modlinkage structures. Module specific data structures.
 *	modlinkage - exported to the kernel when the driver is loaded.
 *	modldrv - describes the module in more detail.
 */

extern struct mod_ops mod_driverops;

static struct modldrv modldrv = {
    &mod_driverops,	/* Should always be &mod_driverops */
    ident,		/* Driver name	*/
    &dp83820_dev_ops	/* Ptr. to dev_ops structure */
};

static struct modlinkage mod_linkage = {
   	MODREV_1,	/* Module Revision number, should be always MODREV_1 */
	&modldrv, 	/* Ptr to modldrv structure. */
	NULL		/* Only one linkage structure	*/
};
 
/* 
 * 	Device access attribute structure
 */
static struct ddi_device_acc_attr dev_attr = {
    DDI_DEVICE_ATTR_V0,
    DDI_STRUCTURE_LE_ACC,
    DDI_STRICTORDER_ACC
};


/* 
 * Global Variables and data structures
 */
static	PVOID	nsm_statep;		/* State pointer	*/
static 	UCHAR 	BroadCastAddr[6] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
static 	UCHAR	nullmac[6] = { 0, 0, 0, 0, 0, 0 };

VOID		FreeResources(int op, dp83820_softstate_t *arg);

/*
 * Macro for String Concatenation
 */

#define STRINGCAT(StrFrom, StrTo, instance, len)\
						{ \
						bcopy((const void *)(StrFrom), (void *)(StrTo), len);\
				StrTo[len]=((instance) + ('0'));\
						StrTo[((len) + 1)]=0;\
}

#define NCARDS  4
#define CACHE_LINE_SIZE  512

/*
 * Global Variables to get configuration values
 */

uint_t TxDrth[NCARDS];
uint_t TxFlth[NCARDS];
uint_t RxDrth[NCARDS];
uint_t uMediaSpeed[NCARDS];
uint_t IntrHoldoff[NCARDS];
uint_t uDuplexMode[NCARDS];
uint_t PauseCounterVal[NCARDS];
uint_t NcBit[NCARDS];
uint_t JumboFrameSize[NCARDS];
uint_t RxFFLO[NCARDS];
uint_t RxFFHI[NCARDS];
uint_t RxSTLO[NCARDS];
uint_t RxSTHI[NCARDS];
uint_t * TxQueueSz;
uint_t * RxQueueSz;
uint_t max_pri_queue;

/*** Function Definitions ***/

/******************************************************************************
 *
 *	Driver Entry Points
 *
 ******************************************************************************/

/******************************************************************************
*f*
*   Name:       	_init
*
*   Description:   	Init Entry point.
*					This routine loads an instance of the driver.
*
*   Parameters:     
*
*   Return Value:   
*					Return value of mod_install() or 
*					Error code of ddi_soft_state_init() if failed.
*f*
******************************************************************************/
INT
_init(VOID)
{
	INT retval = 0;	
/*
 *	Initialize the soft state pointer nsm_statep for MAX_ADAPTERS.
 */
	retval = ddi_soft_state_init(&nsm_statep, 
				sizeof(dp83820_softstate_t), MAX_ADAPTERS);

	if (retval != 0) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"_init : ddi_soft_state_init failed %d\n",retval);
#endif
		return (retval);
	}
/*
 *	add the loadable module 
 */
	retval = mod_install(&mod_linkage);
	if (retval != 0)
	{
		ddi_soft_state_fini(&nsm_statep);
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"_init : mod_install failed\n");
		return (retval);
#endif
	}		
#ifdef NSMDEBUG
cmn_err(CE_WARN,"_init : dp Module Loaded \n");
#endif
	return (retval);

}	/* end of _init()	*/

/******************************************************************************
*f*
*   Name:       	_fini
*
*   Description:   	fini Entry point.
*					This routine is used to unload an instance of the driver.
*
*   Parameters:     
*
*   Return Value:   
*					Return value of mod_remove() / EBUSY. 
*
*f*
******************************************************************************/
INT 
_fini( VOID )
{
    INT     retval = 0;
/*
 *	remove the loadable module 
 */
	retval = mod_remove(&mod_linkage);
	if (retval != 0) { 
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"_fini : mod_remove failed\n");
#endif
        return (EBUSY);
	} 
/*
 *	Free the pointer to soft state structure nsm_statep.
 */
    ddi_soft_state_fini(&nsm_statep);
#ifdef NSMDEBUG
	cmn_err(CE_WARN,"_fini : module removed \n");
#endif
    return (retval);

}	/* end of _fini()	*/

/******************************************************************************
*f*
*   Name:       	_info
*
*   Description:   	 This routine gives the information about the driver.
*
*   Parameters:     
*
*   Return Value:   
*					Return value of mod_info() . 
*
*f*
******************************************************************************/
INT 
_info(struct modinfo *modinfop)
{
/*
 *	Provide information about the loadable module
 */
#ifdef NSMDEBUG
	cmn_err(CE_WARN,"_info : modinfo : %d\n",mod_info(&mod_linkage, modinfop));
#endif
	return(mod_info(&mod_linkage, modinfop));

}	/* end of _info()	*/


/******************************************************************************
*f*
*   Name:       	dp83820_attach()
*
*   Description:   	This auto-configuration entry point is called to attach
*   				a driver instance to the system. Called once for each card.
*
*   Parameters:     
*   				devinfo - pointer to device information structure.
*   				cmd		- Command passed (DDI_ATTACH / ...)
*
*   Return Value:   
*					
*
*f*
******************************************************************************/
STATIC INT 
dp83820_attach(dev_info_t *devinfo, ddi_attach_cmd_t cmd)
{
	dp83820_softstate_t	*statep;
	INT					instance, i;
	gld_mac_info_t		*macinfo;
	AdapterContext  	*pAdapter;
	NsmContext			*pNsm;	
	UINT				BusType;
	INT					status=0;
	INT					irq;
	char				TunableName[50];
#ifdef PROP_CHANGES
	INT					Idx, proplen;
	struct { 
		int instance;
		int speed;
	} SpeedProp[MAX_ADAPTERS];

	INT					MTU_prop;
#endif
	if (cmd != DDI_ATTACH) {
#ifdef NSMDEBUG
	cmn_err(CE_WARN,"dp83820_attach : Invalid cmd %d \n",cmd);
#endif
		return (DDI_FAILURE);
	}


/* 
 * 	Allocate memory for soft state structure .
 */
	instance = ddi_get_instance(devinfo);
	
	if (ddi_soft_state_zalloc(nsm_statep, instance) != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"dp83820_attach:%d:soft state alloc failed\n",instance);
#endif
		return (DDI_FAILURE);
	}
	
	statep = (dp83820_softstate_t *) 
				ddi_get_soft_state(nsm_statep, instance);
	if (statep == NULL) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: get soft state failed\n", instance);
#endif
		ddi_soft_state_free(nsm_statep, instance);
		return DDI_FAILURE;
	}
	statep->dip = devinfo;
/*
 * 	Read and check the bus type from the property file.  
 * 	Read the Speed and Duplex mode from the property file.
 */

/* 
 * 	Memory allocation for macinfo, AdapterContext & NSM context structures. 
 */
	macinfo = (gld_mac_info_t *) gld_mac_alloc(devinfo);
	if (macinfo == NULL) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: NsmAlloc() failed for macinfo\n");
#endif
		ddi_soft_state_free(nsm_statep, instance);
		return DDI_FAILURE;
	}	

	pAdapter = (AdapterContext *) 
			NsmMalloc(sizeof(AdapterContext));
	if (pAdapter == NULL) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: NsmAlloc(AdapterContext) failed \n");
#endif
		ddi_soft_state_free(nsm_statep, instance);
		gld_mac_free(macinfo);
		return DDI_FAILURE;
	}	

	pNsm = (NsmContext *) NsmMalloc(sizeof(NsmContext));
	if (pNsm == NULL) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: NsmAlloc() failed for NSM context\n");
#endif
		ddi_soft_state_free(nsm_statep, instance);
		gld_mac_free(macinfo);
		NsmFree(pAdapter, sizeof(AdapterContext));
		return DDI_FAILURE;
	}	

//	pNsm->DriverStatus = DRV_ATTACHING;
	
	pNsm->free_rtn = (frtn_t *)NsmMalloc(sizeof(frtn_t));
	if (pNsm->free_rtn == NULL) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_attach: NsmMalloc() for free_rtn failed\n");
#endif
		ddi_soft_state_free(nsm_statep, instance);
		gld_mac_free(macinfo);
		NsmFree(pAdapter, sizeof(AdapterContext));
		NsmFree(pNsm, sizeof(NsmContext));
		return DDI_FAILURE;
	} 
	pNsm->free_rtn->free_func = FreeRtn;
	pNsm->free_rtn->free_arg = (char *)pNsm;

/*
 *	Initialize the gldm_private member of macinfo structure to the pointer to 
 *	the OS Context. This is passed by the GLD as part of the GLD interfaces 
 *	(for eg. gldm_send(), gldm_saddr().. etc) to the drivers.
 */
	pNsm->macinfo 			= (gld_mac_info_t *) macinfo;
	pNsm->dip 			= devinfo;
	pNsm->pAdapter = (AdapterContext *) pAdapter;
	pNsm->instance 		= instance;
	pAdapter->pNsmContext		= (NsmContext *)pNsm;
	statep->macinfo = macinfo;
	statep->pAdapter = pAdapter;
	statep->pNsm = pNsm;
	macinfo->gldm_private 		= (caddr_t )pNsm;
/*
 * 	Map in the device address space.
	status = ddi_regs_map_setup(devinfo,2, &(pNsm->regmap_addr),0,0, 
			&dev_attr, pNsm->regmap_handle);

	pAdapter->RegAddr = (UCHAR *)pNsm->regmap_addr;
#ifdef NSMDEBUG
cmn_err(CE_WARN,"dp83820_attach: Reg Addr 0x%x\n", pNsm->regmap_addr);
#endif

	if (status != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"dp83820_attach: ddi_regs_map_setup() failed %d\n", status);
#endif
		FreeResources( REGMAP_FAILURE, statep);
		return DDI_FAILURE;
	}
 */
 
/*
 * 	Set up the necessary resources for enabling data accesses to the PCI Local
 *	bus configuration space.
 */
	status = pci_config_setup(devinfo, &pNsm->pci_handle) ;
	if (status == DDI_FAILURE) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: pci_config_setup failed with error %d\n",status);
#endif
		FreeResources( PCI_FAILURE, statep);
		return DDI_FAILURE;
	}
/* 
 * 	Call ReadPCI_Config() to read the PCI related values from the configuration
 *	space and update the NSM related fields in the AdapterContext. 
 */
	status = ReadPCI_Config(pAdapter) ;
	if (status != ADAPTER_FOUND) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: Adapter NOT FOUND !!!!!\n");
#endif
//		FreeResources( ADAPTER_NOT_FOUND, pNsm);
		FreeResources( ADAPTER_NOT_FOUND, statep);
		return DDI_FAILURE;
	}

	STRINGCAT("TxDrth_", TunableName, instance, 7);
	TxDrth[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 0);

	STRINGCAT("RxDrth_", TunableName, instance, 7);
	RxDrth[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 0);

	STRINGCAT("TxFlth_", TunableName, instance, 7);
	TxFlth[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 2);

	STRINGCAT("IntrHoldoff_", TunableName, instance, 12);
	IntrHoldoff[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 1);

	STRINGCAT("uMediaSpeed_", TunableName, instance, 12);
	uMediaSpeed[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 0);

	STRINGCAT("uDuplexMode_", TunableName, instance, 12);
	uDuplexMode[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 0);

	STRINGCAT("PauseCounterVal_", TunableName, instance, 16);
	PauseCounterVal[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 400);

	STRINGCAT("NcBit_", TunableName, instance, 6);
	NcBit[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 1);

	STRINGCAT("JumboFrameSize_", TunableName, instance, 15);
	JumboFrameSize[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 1514);

	STRINGCAT("RxFFLO_", TunableName, instance, 7);
	RxFFLO[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 2);

	STRINGCAT("RxFFHI_", TunableName, instance, 7);
	RxFFHI[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 4); 

	STRINGCAT("RxSTLO_", TunableName, instance, 7);
	RxSTLO[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 2);

	STRINGCAT("RxSTHI_", TunableName, instance, 7);
	RxSTHI[instance]=(uint_t)ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, TunableName, 4);

	max_pri_queue = ddi_prop_get_int(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, "max_pri_queue", 4);

	if (TxQueueSz == NULL ) {
		if(ddi_prop_lookup_int_array(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, "TxQueueSz", (int **) &TxQueueSz, &max_pri_queue) != DDI_PROP_SUCCESS)
       cmn_err(CE_WARN, "dp83820_attach: Getting the Values of TxQueueSz has Failed");
    }
	if (RxQueueSz == NULL ) {
		if(ddi_prop_lookup_int_array(DDI_DEV_T_ANY, devinfo, DDI_PROP_NOTPROM | DDI_PROP_DONTPASS, "RxQueueSz", (int **) &RxQueueSz, &max_pri_queue) != DDI_PROP_SUCCESS)
		cmn_err(CE_WARN, "dp83820_attach: Getting the Values of RxQueueSz has Failed");
	} 

/*
 *	Number of Priority queues supported by the OS and the checksum support ,
 *	Jumbo Frame size will be stored in the AdapterContext strucutre.
 */
	pAdapter->OsPrio = OS_PRIQUE;
	pAdapter->MaxPktSize = RX_BUF_SIZE;

	for(i=0;i< MAXPRI_ADAPTER; i++) { 

		pAdapter->TxQueueSz[i] = TxQueueSz[i];
		pAdapter->RxQueueSz[i] = RxQueueSz[i];
	} 

	pAdapter->TxDrth = TxDrth[instance];	
	pAdapter->TxFlth = TxFlth[instance];	
	pAdapter->RxDrth = RxDrth[instance];	
	pAdapter->UserMediaSpeed = uMediaSpeed[instance];
	pAdapter->UserDuplexMode = uDuplexMode[instance];
	pAdapter->PauseCounterVal = PauseCounterVal[instance];
	pAdapter->NcBit = NcBit[instance];
	pAdapter->RxFFLO = RxFFLO[instance];
	pAdapter->RxFFHI = RxFFHI[instance];
	pAdapter->RxSTLO = RxSTLO[instance];
	pAdapter->RxSTHI = RxSTHI[instance];
	pAdapter->TxMaxDMASize = CACHE_LINE_SIZE;
	pAdapter->RxMaxDMASize = CACHE_LINE_SIZE;
		
/*
 * 	Fill in the fields of Adapter context and 
 *	call HsmInitContext() to initialize the HSM related fields in AdapterConext
 */
	HsmInitContext(pAdapter);

	pAdapter->IntrHoldoff = IntrHoldoff[instance];

//	pAdapter->PhysCapabilities &= ~(BIG_ENDIAN | JUMBO_FRAMES_ON | SET_WOL_ON | SET_AUTO_NEG_ON);
	pAdapter->PhysCapabilities &= ~(BIG_ENDIAN | JUMBO_FRAMES_ON | SET_WOL_ON | 
			SET_RX_CHKSUM_OFFLOAD_ON | VLAN_TAG_INSERTION_GEN_ON | 
			TX_CHKSUM_OFFLOAD_ON_GEN );

#ifdef PROP_CHANGES
	proplen = sizeof(MTU_prop);
	status = ddi_prop_op(DDI_DEV_T_NONE, devinfo, PROP_LEN_AND_VAL_BUF, 
				DDI_PROP_DONTPASS, "mtu", (caddr_t) &MTU_prop, &proplen);

	if (status != DDI_PROP_SUCCESS) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "MTU property could not be found.. ");
#endif
		MTU_prop = MAX_ETH_PKT_SIZE;
	}  else { 
		if (MTU_prop > MAX_MTU_SIZE) {  
			MTU_prop = MAX_MTU_SIZE;
			pAdapter->PhysCapabilities |= (JUMBO_FRAMES_ON);
		} 
		if (MTU_prop < ETH_HDR_SIZE)
			MTU_prop = MAX_ETH_PKT_SIZE;
	} 
#endif

/* 
 *  Reading the Speed, Duplex Mode and other entries from .conf files. 
 */
#ifdef PROP_CHANGES
	proplen = sizeof(SpeedProp);
	status = ddi_prop_op(DDI_DEV_T_NONE, devinfo, PROP_LEN_AND_VAL_BUF, 
				DDI_PROP_DONTPASS, "speed", (caddr_t) &SpeedProp, &proplen);

	if (status != DDI_PROP_SUCCESS) { 

#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "Speed property could not be found.. ");
#endif
		pAdapter->PhyCapabilities |= (SET_AUTO_NEG_ON); 

	}  else { 

		for (Idx = 0; Idx < MAX_ADAPTERS; Idx++)
			if (SpeedProp[Idx].instance == instance) 
				break;

		if (Idx < MAX_ADAPTERS)  { 
			switch(SpeedProp[Idx].speed) { 
				case 10HD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				case 10FD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				case 100HD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				case 100FD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				case 1000HD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				case 1000FD : 
					MediaSpeed = 10;
					DuplexMode = HALF_DUPLEX;
					break;
				default : 
					MediaSpeed = 0;
					DuplexMode = 0;
					pAdapter->PhysCapabilities |= (SET_AUTO_NEG_ON);
					break;
			} 
		} else { 
#ifdef NSMDEBUG
			cmn_err(CE_NOTE, "Speed property for the current instance could not be found.. ");
#endif
			pAdapter->PhyCapabilities |= (SET_AUTO_NEG_ON); 
		} 
	} 
		
#endif

/*
 *	Create a Interrupt property.This interrupt property is used by GLD to add
 *	Interrupt service routine.
 */
	status = ddi_prop_create(DDI_DEV_T_NONE, devinfo, DDI_PROP_CANSLEEP, "intr",
				(caddr_t)&pAdapter->IRQ, sizeof(int));

	if (status != DDI_PROP_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: ddi_prop_create() failed with error %d\n", status);
#endif
//		FreeResources( INTR_PROP, pNsm);
		FreeResources( INTR_PROP, statep);
		return DDI_FAILURE;
	}

/*
 *	Create an Interrupt block cookie and initialize pNsm->NsmGenLock.
 */
	status = ddi_get_iblock_cookie(devinfo, 0, &macinfo->gldm_cookie);
	if (status != DDI_SUCCESS) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"dp83820_attach: ddi_get_iblock_cookie() failed\n");
#endif
//		FreeResources(IBLOCK_COOKIE, pNsm);
		FreeResources(IBLOCK_COOKIE, statep);
		return DDI_FAILURE;
	} 

#ifdef NSMDEBUG
cmn_err(CE_WARN, "dp83820_attach: Initializing the lock \n");
#endif
	mutex_init(&pNsm->NsmGenLock, NULL, MUTEX_DRIVER, macinfo->gldm_cookie);

/*
 * Add the interrupt Service routine for the driver. 
 */
	status = ddi_add_intr(devinfo, 0, &macinfo->gldm_cookie, 
		(ddi_idevice_cookie_t *)NULL, gld_intr, (caddr_t) macinfo);

	if (status != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"dp83820_attach: ddi_add_intr() failed with error %d\n", status);
#endif
//		FreeResources(ADD_INTR, pNsm);
		FreeResources(ADD_INTR, statep);
		return DDI_FAILURE;
	}
/* 
 *	Register the driver with GLD interface. 
 *  gld_register() does the following operations.	
 *  1. Get interrupt cookie and initialise the mutex lock.
 *	2. Get the instance number of the device (UNIQUE) and store it as PPA.
 *  3. Create minor node number for the adapter.
 *	4. Map the registers.
 *	5. Add the interrupt service routine.
 */
	macinfo->gldm_ident = ident;
	macinfo->gldm_type = DL_ETHER;
	macinfo->gldm_minpkt = DP83820_MINPKT;
#ifdef PROP_CHANGES
	macinfo->gldm_maxpkt = MTU_prop - ETH_HDR_SIZE;
#else
	macinfo->gldm_maxpkt = JumboFrameSize[instance] - ETH_HDR_SIZE;
//	macinfo->gldm_maxpkt = MAX_ETH_PKT_SIZE - ETH_HDR_SIZE;
//	macinfo->gldm_maxpkt = MAX_ETH_PKT_SIZE ;
//	macinfo->gldm_maxpkt = RX_BUF_SIZE ;
#endif
	macinfo->gldm_addrlen = ETHERADDRL;
	macinfo->gldm_saplen = -2;

	macinfo->gldm_reset = dp83820_reset;
	macinfo->gldm_start = dp83820_start_board;
	macinfo->gldm_stop	= dp83820_stop_board;
	macinfo->gldm_send = dp83820_send;
	macinfo->gldm_intr = dp83820_intr;
	macinfo->gldm_ioctl = dp83820_ioctl;

	macinfo->gldm_set_mac_addr = dp83820_saddr;
	macinfo->gldm_set_multicast = dp83820_dlsdmult;
	macinfo->gldm_set_promiscuous = dp83820_prom;
	macinfo->gldm_get_stats = dp83820_gstat;
	
	macinfo->gldm_broadcast_addr = BroadCastAddr;
	macinfo->gldm_vendor_addr = pAdapter->PermMacAddr;
	macinfo->gldm_ppa = instance;
	macinfo->gldm_devinfo = devinfo;

	status =  gld_register(devinfo, "dp", macinfo);
	if ( status != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_attach: gld_register failed for instance %d with error %d \n", instance, status);
#endif
//		FreeResources( GLD_FAILURE, macinfo);
		FreeResources( GLD_FAILURE, statep);
		return DDI_FAILURE;
	}
/*
 *	Call HsmInitialize() to initialize the HSM. 
 */
	status = HsmInitialize(pAdapter);
	if (status != SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"dp83820_attach: HsmInitialize() failed\n");
#endif
//		FreeResources(HSMINIT_FAILURE, macinfo);
		FreeResources(HSMINIT_FAILURE, statep);
		return DDI_FAILURE;
	}


	status = HsmReset(pAdapter, 0);
	if (status != SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"dp83820_attach: HsmReset() failed\n");
#endif
//		FreeResources(HSMRESET_FAILURE, pAdapter);
		FreeResources(HSMRESET_FAILURE, statep);
		return DDI_FAILURE;
	}
/*
	status = HsmOpen(pAdapter);
	if (status != SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"dp83820_attach: HsmOpen() failed\n");
#endif
//		FreeResources(HSMOPEN_FAILURE, pAdapter);
		FreeResources(HSMOPEN_FAILURE, statep);
		return DDI_FAILURE;
	}
*/

//	HsmRxFilter(pAdapter, ACCEPT_ALL_MULTICAST_ON | ACCEPT_ALL_BROADCAST_ON | 
//		ACCEPT_PERFECT_MATCH_ON);
	HsmRxFilter(pAdapter, PROMISCUOUS_ON );
//cmn_err(CE_NOTE, "Perm Mac Address %x , Curr Mac Address %x\n", 
//	pAdapter->PermMacAddr, pAdapter->CurrMacAddr);

//	pNsm->DriverStatus = DRV_ATTACHED;
#ifdef NSMDEBUG 
	cmn_err(CE_WARN,"dp83820_attach : returns DDI_SUCCESS\n");
#endif
	return (DDI_SUCCESS);

}	/* end of dp83820_attach()	*/

/******************************************************************************
*f*
*   Name:       	dp83820_detach()
*
*   Description:   	This auto-configuration entry point is called to detach
*   				a driver instance to the system. Called once for each card.
*
*   Parameters:     
*   				devinfo - pointer to device information structure.
*   				cmd		- Command passed (DDI_DETACH / ...)
*
*   Return Value:   
*					
*
*f*
******************************************************************************/
STATIC INT
dp83820_detach(dev_info_t	*devinfo, ddi_detach_cmd_t	cmd)
{
	AdapterContext 	*pAdapter;
	NsmContext	*pNsm;
	gld_mac_info_t		*macinfo;
	INT		instance;	

	if (cmd != DDI_DETACH)
		return (DDI_FAILURE);

//	pNsm->DriverStatus = DRV_DETACHING;

	macinfo = (gld_mac_info_t	*)ddi_get_driver_private(devinfo);
	pNsm	= (NsmContext *) macinfo->gldm_private;
	pAdapter = (AdapterContext *) pNsm->pAdapter;
/*
 *	Reset the Adapter , Close the adapter.
 *	Call HsmUnInitialize() to free memory allocated for TCB, RCB, Txd, Rxd.
 */
	dp83820_stop_board(macinfo);
//	HsmUnInitialize(pAdapter);
/*
 *	Free the resources allocated in dp83820_attach() like memory for AdapterContext.
 */
//	FreeResources(DETACH, pAdapter);
	FreeResources(DETACH, (dp83820_softstate_t *) ddi_get_soft_state(nsm_statep, ddi_get_instance(devinfo)));

	instance = ddi_get_instance(devinfo);
/*
 *  Freeing the memory allocated for properties TxQueueSz and RxQueueSz
 */
	if ( TxQueueSz != NULL ) {
		ddi_prop_free(TxQueueSz);
		TxQueueSz = NULL;
	}
	if ( RxQueueSz != NULL ) {
		ddi_prop_free(RxQueueSz);
		RxQueueSz = NULL;
	}

//	pNsm->DriverStatus = DRV_DETACHED;
	return (DDI_SUCCESS);

}	/* end of dp83820_detach()	*/

/******************************************************************************
 *
 *	GLD Entry Points
 *
 ******************************************************************************/

STATIC INT
dp83820_start_board(gld_mac_info_t	*macinfo)
{
	AdapterContext	*pAdapter;
	NsmContext		*pNsm;

	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter= pNsm->pAdapter;

	if (!(pAdapter->AdapterStatus & ADAPTER_INITIALIZED))
		return DDI_SUCCESS;

	mutex_enter(&pNsm->NsmGenLock);

	if (HsmOpen(pAdapter) != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_start_board() : HsmOpen() failed\n");
#endif
		mutex_exit(&pNsm->NsmGenLock);
		return (DDI_FAILURE);
	}


	mutex_exit(&pNsm->NsmGenLock);

	HsmRxFilter(pAdapter, ACCEPT_ALL_MULTICAST_ON | ACCEPT_ALL_BROADCAST_ON | 
		ACCEPT_PERFECT_MATCH_ON);
	
	return (DDI_SUCCESS);
}


STATIC INT
dp83820_stop_board(gld_mac_info_t	*macinfo)
{
	AdapterContext	*pAdapter;
	NsmContext		*pNsm;

	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter = pNsm->pAdapter;

	mutex_enter(&pNsm->NsmGenLock);

	if (HsmClose(pAdapter) != SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_stop_board() : HsmClose() failed\n");
#endif
		mutex_exit(&pNsm->NsmGenLock);
		return (DDI_FAILURE);
	}
	mutex_exit(&pNsm->NsmGenLock);
	return (DDI_SUCCESS);
}	

/*
 *	dp83820_send()	: 	Called by the GLD to send the packet to the adapter. 
 *					Passes the macinfo structure and the pointer to the message.
 */
INT
dp83820_send(gld_mac_info_t	*macinfo, mblk_t	*mp)
{
	NsmContext			*pNsm;
	AdapterContext		*pAdapter;
	mblk_t				*tmp_mp;
	int					mblk_cnt = 0;
	int					length = 0;
	int					msglen = 0;
	INT					PktSent = 0;
	static int			reentrant;
	HsmTCB				*TCB;
	int					TCBcurr;
	int					status;
	PktStruct			pkt;
	mblk_t				*new_mp = NULL;
//	PktInfo				pktinfo;
	int i;
	unsigned char		*tmp1, *tmp2;
	
	pNsm = (NsmContext *) (macinfo->gldm_private);
	pAdapter= pNsm->pAdapter;
	
/*
 *	If the Adapter is not ready or the link is not up then return GLD_NORESOURCES.
 */
	if (!(pAdapter->AdapterStatus & ADAPTER_OPEN) &&
		 !(pAdapter->AdapterStatus & LINK_UP) )
			return 	GLD_NORESOURCES;

/*
 *	Split the message into contiguous fragments and store the fragment addresses
 * 	and sizes in PktArray->FragArray[].ptr and PktArray->FragArray[].size
 */
	bzero(&pkt, sizeof(pkt));
	pkt.PktCount = 1;	/* GLD sends one packet at a time */
//	status = FragmentMessage(&pktinfo, mp);
//	new_mp = msgpullup(mp, -1);
//	if (new_mp == NULL) { 
//		cmn_err(CE_WARN, "msgpullup1 failed \n");
//		return GLD_NORESOURCES;
//	} 
//	freemsg(mp);
//	status = FragmentMessage(&pkt.PktArray[0], new_mp);
	status = FragmentMessage(&pkt.PktArray[0], mp);
	if (status == TOOMANY_FRAGS) {
		new_mp = msgpullup(mp, -1);
		if (new_mp == NULL) { 
			cmn_err(CE_WARN, "msgpullup failed \n");
			return GLD_NORESOURCES;
		} 
		else { 
#ifdef NSMDEBUG
			cmn_err(CE_WARN, "FragmentMessage : msgpullup succeded %x %x\n", mp, new_mp);
#endif
			status = FragmentMessage (&pkt.PktArray[0], new_mp);
//			status = FragmentMessage (&pktinfo, new_mp);
			if (status != DDI_SUCCESS) { 
#ifdef NSMDEBUG
				cmn_err(CE_WARN, "FragmentMessage after msgpullup failed %d\n", status);
#endif
				freemsg(new_mp);
				return GLDE_RETRY;
			} 
		} 
			
	} else if (status == BADPACKET)  { 
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "FragmentMessage : BAD Packet %x \n", mp);
#endif
		freemsg(mp);
		return(DDI_SUCCESS);
	} else if (status != DDI_SUCCESS) { 
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "FragmentMessage failed %d\n",status);
#endif
		return GLDE_RETRY;
	} 

#ifdef NSMDEBUG
	for(i=0;i<pkt.PktArray[0].NumFrags;i++)
		cmn_err(CE_WARN, "send: nfrgs %d ptr %x len %d\n", i+1,
       		pkt.PktArray[0].FragArray[i].pFrag,
        	pkt.PktArray[0].FragArray[i].FragLen );
#endif
	
/*
 *	Call HsmSendPackets() to send the packet array which has the fragment 
 *	information to the adapter.
 */
#ifdef NSMDEBUG
	cmn_err(CE_WARN, "dp83820_send: msbp 0x%x newmp = 0x%x\n", mp, new_mp);
#endif
	reentrant++;
	if(reentrant > 1 ){
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "FUNCTION is reentering mp =0x%x, 0x%x\n", mp, reentrant);
#endif
		reentrant--;
		return GLDE_RETRY;
	}
	PktSent = HsmSendPkts(pAdapter, &pkt, 0);
	reentrant--;
#ifdef NSMDEBUG
	cmn_err(CE_WARN, "dp83820_send: msbp 0x%x SENT XXXX\n", mp, new_mp);
#endif
//	PktSent = HsmSendPacket(pAdapter, &pktinfo, 0);
	if (PktSent == pkt.PktCount) { 
#ifdef STAT_CHANGES
		macinfo->gldm_stats.glds_bytesxmt64 += msgdsize(mp);
#endif
	} else { 
#ifdef NSMDEBUG
		cmn_err(CE_WARN, "dp83820_send(): Pkts sent %d %d\n",PktSent, pkt.PktCount);
#endif
		return GLDE_RETRY;
	} 

	if(new_mp != NULL)
		freemsg(mp);
	return (DDI_SUCCESS);

}	/* end of dp83820_send()	*/

/*
 *	dp83820_intr()	:	Called by GLD when there is a device interrupt. 
 *				calls HsmInterruptService() to handle the interrupt.
 */
STATIC UINT 
dp83820_intr(gld_mac_info_t *macinfo) 
{
	AdapterContext	*pAdapter;
	NsmContext		*pNsm;	

	pNsm = (NsmContext	*)macinfo->gldm_private;
	pAdapter = pNsm->pAdapter;

	if (!pAdapter->interruptStatus) { 
		if (HsmIsr(pAdapter) != SUCCESS) 
			return (DDI_INTR_UNCLAIMED);
	} 

	return (DDI_INTR_CLAIMED);
}	/* end of dp83820_intr	*/

/*
 *	dp83820_ioctl()	: IOCTL	routine called by GLD.
 */
static int
dp83820_ioctl(gld_mac_info_t *macinfo, queue_t	*wq, mblk_t	*mp) 
{
	gld_t				*gldp;		/* Pointer to GLD private	*/
	AdapterContext		*pAdapter; 	/* Pointer to AdapterContext */
	NsmContext			*pNsm; 		/* Pointer to OSContext */
	nsm_ioctl_t			*ic;		/* Ptr to IOCTL_t structure */
	struct iocblk       *ctl;		/* Ptr to IOCTL structure for M_IOCTL type */
	int					status;
	int					MediaSpeed, DuplexMode;

	struct	ether_addr	*multaddr;		/* Multicast address	*/

	gldp =  (gld_t *)(wq->q_ptr);   /* gld private */

	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter = pNsm->pAdapter;

	ctl = (struct iocblk *)mp->b_rptr;
	
	if (ctl->ioc_count == TRANSPARENT) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_ioctl: transparent ioctl");
#endif
		goto err;	
	}

	if (mp->b_cont == NULL) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_ioctl: unknown ioctl cmd %d",
			((struct iocblk *)mp->b_rptr)->ioc_cmd);
#endif
		goto err;
	}

	ic = (nsm_ioctl_t *)mp->b_cont->b_rptr;

	switch(ic->cmd) {
	
		case ADD_MCAST:		/*	Add multicast address	*/
			multaddr = (struct ether_addr *)ic->buf;
			status = dp83820_dlsdmult(macinfo, multaddr, 1);
			if (status != SUCCESS)
				goto err;
			break;

		case DELETE_MCAST:	/*	Delete multicast address	*/
			multaddr = (struct ether_addr *)ic->buf;
			status = dp83820_dlsdmult(macinfo, multaddr, 0);
			if (status != SUCCESS)
				goto err;
			break;

		case CHANGE_DATARATE:	/*	Change Duplex type and data rate	*/
			MediaSpeed = (int) ic->arg1;	
			DuplexMode = (int) ic->arg2;	
			
/*
 *			if (AutoNegotiation is supported by the adapter ) {
 *				Tell the adapter to do autonegotiation 
 *				break;
 *			}
 */
			if ( (MediaSpeed == pAdapter->MediaSpeed) && 
			   (DuplexMode == pAdapter->DuplexMode) ) {
#ifdef NSMDEBUG
				cmn_err(CE_NOTE,"dp83820_ioctl : Datarate and duplex modes are already set\n");
#endif
				break;
			}	/*	end of if()	*/

			status = HsmReset(pAdapter, 0);
			if (status != SUCCESS) {  
#ifdef NSMDEBUG
				cmn_err(CE_NOTE, "dp83820_ioctl : HsmReset failed\n");
#endif
				goto err;
			}
			status = HsmOpen(pAdapter);
			if (status != SUCCESS) {  
#ifdef NSMDEBUG
				cmn_err(CE_NOTE, "dp83820_ioctl : HsmOpen failed\n");
#endif
				goto err;
			}
			pAdapter->MediaSpeed = MediaSpeed;
			pAdapter->DuplexMode = DuplexMode;

			macinfo->gldm_media = GLDM_TP;	/* 	Twisted pair	*/
			break;
		
		deafult:
#ifdef NSMDEBUG
			cmn_err(CE_NOTE, "dp83820_ioctl: unknown ioctl 0x%x\n", ic->cmd);
#endif
			goto err;

	}	/*	end of switch()	*/

	ctl->ioc_rval = status;
	mp->b_datap->db_type = M_IOCACK;
	qreply(wq, mp);
	return (SUCCESS);

err:
	ctl->ioc_rval = -1;
	mp->b_datap->db_type = M_IOCNAK;
	qreply(wq, mp);
	return (FAILURE);
	
}

STATIC INT
dp83820_reset(gld_mac_info_t	*macinfo)
{
	AdapterContext	*pAdapter;
	NsmContext			*pNsm;

	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter = pNsm->pAdapter;

	if (HsmReset(pAdapter, 0) != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_reset : HsmReset() failed\n");
#endif
		return (DDI_FAILURE);
	}
/*
	if (HsmOpen(pAdapter) != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_reset : HsmOpen() failed\n");
#endif
		return (DDI_FAILURE);
	}
*/

	return DDI_SUCCESS;
}

	
STATIC INT
dp83820_gstat (gld_mac_info_t *macinfo, struct gld_stats *stats)
{
	return DDI_SUCCESS;
}

/*
 *	dp83820_dlsdmult() - Function to enable/disable multicast addresses.
 */
STATIC INT
dp83820_dlsdmult(gld_mac_info_t	*macinfo, struct ether_addr *macaddr, int op)
{
	NsmContext	*pNsm = (NsmContext *)macinfo->gldm_private;	
	AdapterContext	*pAdapter= pNsm->pAdapter;
	MultiList	TempMultiList;
	INT			status = 0;

/*
 *	check whether the ether_addr_octet passed is not a null mac (all octets set
 *	to 0.
 */
	if(CMP_MAC(macaddr->ether_addr_octet,nullmac)) 
		return GLD_BADARG;

/*
 *	op passed indicates the operation to be done on the passed multicast
 *	adderess macaddr; Value of 1 in op indicates the addition and 
 *	value of 0 indicates the deletion.
 */

	if(CMP_MAC(macaddr->ether_addr_octet,pAdapter->CurrMacAddr))
		return (DDI_SUCCESS); 		/* no need to set this address */

/*
 *	Check whether the passed address is a valid Multicast address. If not 
 *	return  DL_BADADDR. For valid Multicast address Copy the Multicast address
 *	to AdapterContext->multi_addr and call HsmAddMultiAddress() / 
 *	HsmDeleteMultiAddress() based on the op passed.
 */
	if (macaddr->ether_addr_octet[0] & 0x01) {

		CPY_MAC(macaddr->ether_addr_octet, TempMultiList.MulticastAddr);
		TempMultiList.Next = NULL;

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[0], TempMultiList.MulticastAddr[0]);
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[1], TempMultiList.MulticastAddr[1]);
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[2], TempMultiList.MulticastAddr[2]);
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[3], TempMultiList.MulticastAddr[3]);
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[4], TempMultiList.MulticastAddr[4]);
cmn_err(CE_NOTE, "ether octet[0] %x, multicastaddr %x\n",	macaddr->ether_addr_octet[5], TempMultiList.MulticastAddr[5]);
#endif

		if (op == GLD_MULTI_ENABLE)
			status = HsmMulticastAdd(pAdapter, &TempMultiList, FALSE);
		else
			status = HsmMultiCastDelete(pAdapter, &TempMultiList);

		if (status != SUCCESS) {
			if (op == GLD_MULTI_ENABLE)
				return GLD_NORESOURCES;	/* Multicast table full	*/
			else
				return GLD_BADARG;	/* Promiscuous mode not enabled */
		}
		return DDI_SUCCESS;
	} 
	else 
		return GLD_BADARG;

}	/* end of dp83820_dlsdmult()	*/

/*
 * Set the physical address on the board.
 */
STATIC INT  
dp83820_saddr(gld_mac_info_t *macinfo, UCHAR *macaddr)
{
	AdapterContext	*pAdapter;
	NsmContext		*pNsm;
	struct 	ether_addr	tmp_macaddr;

#ifdef NSMDEBUG
	cmn_err(CE_NOTE, "dp83820_saddr : comp1 %d \n", (macaddr[0] & 0x80));
	cmn_err(CE_NOTE, "dp83820_saddr : comp2 %d \n", CMP_MAC(macaddr , nullmac));
#endif
	
	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter= pNsm->pAdapter;

	mutex_enter(&pNsm->NsmGenLock);
/*
 *	If the Address is a NULL address then return FAILURE.
 */
#ifdef NSMDEBUG
	cmn_err(CE_NOTE, "macaddr[0] %x \n", macaddr[0]);
#endif

	if ( ((!macaddr) || macaddr[0] & 0x80) || CMP_MAC(macaddr,nullmac) )  {
		mutex_exit(&pNsm->NsmGenLock);
		return (GLD_BADARG);
	} 
/*
 *	If the passed MAC address is already set then return SUCCESS.
 *	if not, copy the MAC address in AdapterContext->mac_address and 
 *	call HsmReset.
 */
	if ( CMP_MAC(macaddr,macinfo->gldm_vendor_addr) ) {
		mutex_exit(&pNsm->NsmGenLock);
		return SUCCESS;
	} 

	CPY_MAC(macaddr, pAdapter->CurrMacAddr);

/*
	HsmReset(pAdapter, 0);
	dp83820_start_board(macinfo);
*/
	/* Revisit Should call HsmSetMacAddr */

	mutex_exit(&pNsm->NsmGenLock);
	return SUCCESS;
}

/*
 *	dp83820_prom()	-- sets the promiscuous mode On/Off. Called from GLD.
 */
STATIC INT
dp83820_prom(gld_mac_info_t	*macinfo, int on)
{
	AdapterContext	*pAdapter;
	NsmContext			*pNsm;
	INT			mode;
/* 
 *	Accept All physical unicast packets, multicast packets, broadcast 
 *	packets
 */
	pNsm = (NsmContext *)macinfo->gldm_private;
	pAdapter= pNsm->pAdapter;

/* 
 * Call HsmSetRxMode() for enabling/disabling promiscuous mode using the mode
 * set.
 */
	if (on == GLD_MAC_PROMISC_PHYS || on == GLD_MAC_PROMISC_MULTI)
		HsmRxFilter(pAdapter, PROMISCUOUS_ON);
	else
		HsmRxFilter(pAdapter, PROMISCUOUS_OFF|ACCEPT_ALL_MULTICAST_ON |
			 ACCEPT_ALL_BROADCAST_ON | ACCEPT_PERFECT_MATCH_ON);

	return (DDI_SUCCESS);
}


/******************************************************************************
 *
 *	Other Routines
 *
 ******************************************************************************/

/******************************************************************************
*f*
*   Name:       	ReadPCI_Config()
*
*   Description:   	This auto-configuration entry point is called to detach
*   				a driver instance to the system. Called once for each card.
*
*   Parameters:     
*   				devinfo - pointer to device information structure.
*   				cmd		- Command passed (DDI_DETACH / ...)
*
*   Return Value:   
*					
*
*f*
******************************************************************************/
INT
ReadPCI_Config(AdapterContext	*pAdapterContext)
{
	UINT		RegVal;
	NsmContext	*pNsm;
	UINT		vendor_id;
	UINT		device_id;
	UINT        	Cfg_val,Srr_val;

	pNsm = pAdapterContext->pNsmContext;
/* 
 * Read the Vendor ID and Device ID from the PCI register space. 
 */
	RegVal = pci_config_get32(pNsm->pci_handle, CFGID);
	vendor_id = RegVal & VENDOR_ID_MASK;
	device_id = RegVal & DEVICE_ID_MASK;

	if (vendor_id != VENDOR_ID || device_id != DEVICE_ID) {
#ifdef NSMDEBUG
		cmn_err(CE_WARN,"Vendor and Device IDs doesn't match. Expected 0x%x 0x%x & read from PCI config space 0x%x 0x%x Value read from PCI 0x%x\n",VENDOR_ID, DEVICE_ID, vendor_id, device_id, RegVal);
#endif
		return (ADAPTER_NOT_FOUND);
	}
/* 
 *  Make sure busmaster enable, memory space access , and I/O space access 
 * 	are enabled in the CR (command register).
 */ 
	RegVal = pci_config_get32(pNsm->pci_handle, CFGCS);
	RegVal |= (BMEN );
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : CFGCS value 0x%x\n",RegVal);
#endif
	pci_config_put32(pNsm->pci_handle, CFGCS, RegVal);
/* 
 * 	Read the IRQ from ILINE in CFGINT register.
 */
	RegVal = pci_config_get8(pNsm->pci_handle, CFGINT);
	pAdapterContext->IRQ = (RegVal & ILINE_MASK);
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : CFGINT value 0x%x\n",RegVal);
#endif
/*
 * 	Get the address of I/O Base Address register (CFGIOA) and Memory Address
 *	register (CFGMA). 
 */
	RegVal = pci_config_get32(pNsm->pci_handle, CFGIOA);
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : CFGIOA value 0x%x\n",RegVal);
#endif
	if (!(RegVal & IOIND)) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_attach: The chip is not capable of being mapped to IO space\n");
#endif
	} else 
		pNsm->IOBase = (RegVal & IOBASE_MASK);
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : IO Base 0x%x\n",pNsm->IOBase);
#endif

	RegVal = pci_config_get32(pNsm->pci_handle, CFGMA);
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : CFGMA value 0x%x\n",RegVal);
#endif
	if (!(RegVal & MEMIND))
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "dp83820_attach: the chip is not capable of being mapped into memory space"); 
#endif
	pNsm->MemBase = (RegVal & MEMBASE_MASK);
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "ReadPCI_Config : Mem Base 0x%x\n",pNsm->MemBase);
#endif

/*	pAdapterContext->RegAddr = (UCHAR *)pNsm->MemBase;  */
	pAdapterContext->RegAddr = (UCHAR *)pNsm->IOBase; 

	/*	Work Around for a 8 byte Replication issue.
		This is typically required for 32 bit bus and if the
		silicon revision of the card is less  than or equal to 0x103
		Fix: Increase the latency timer( ie bits 8 to 15 of CFGLAT)
		value to 0xFE

  	*/
	
	NsmRegRead32(pAdapterContext->pNsmContext,
			(pAdapterContext->RegAddr + SRR), &Srr_val); 
	if(Srr_val <= 0x103)
	{	
		NsmRegRead32(pAdapterContext->pNsmContext,
				(pAdapterContext->RegAddr + CFG), &Cfg_val); 
		if(!(Cfg_val & PCI64_DET))
		{ 
			RegVal = pci_config_get32(pNsm->pci_handle, CFGLAT);
			RegVal &=0xFFFF00FF;
			RegVal |= 0xFE00 ; 		
			pci_config_put32(pNsm->pci_handle, CFGLAT, RegVal);
		}
	}


	return (ADAPTER_FOUND);

}	/*	end of ReadPCI_Config	*/

/******************************************************************************
*f*
*   Name:       	NsmMallocContiguous()
*
*   Description:   	Utility routine to allocate contiguous memory.
*
*   Parameters:     
*
*   Return Value:   
*
*f*
******************************************************************************/
PVOID 
NsmMallocContiguous(NsmContext *pNsm, AddrStruct *pAddr, UINT align, UINT cached)
{
	int			status;
	ulong		alloc_len;

	ddi_dma_attr_t          dma_attr;
	dev_info_t				*devinfo;
	ddi_dma_cookie_t        cookie;
    UINT cookiec;
	dp83820_softstate_t	*statep;
	NsmCookie		*pNsmCookie;
	
	devinfo = pNsm->dip;

	pAddr->VirtAddr = pAddr->PhysAddr = NULL;

	pNsmCookie = (NsmCookie *)NsmMalloc(sizeof(NsmCookie));
	if (pNsmCookie == NULL) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "NsmMallocContiguous : NsmCookie allocation failed\n");
#endif
		return;
	} 
/* 
 *	Populate DMA attribute structure with physical memory alignment 
 *	specifications.
 */
	dma_attr.dma_attr_version = DMA_ATTR_V0;
    dma_attr.dma_attr_addr_lo = 0;
    dma_attr.dma_attr_addr_hi = 0xFFFFFFFF;
    dma_attr.dma_attr_count_max = 0x00FFFFFF;
    dma_attr.dma_attr_align = 1;		/* Byte alignment */
    dma_attr.dma_attr_burstsizes = 0x00FFFFFF;
    dma_attr.dma_attr_minxfer = 1;
 
    dma_attr.dma_attr_maxxfer = 0x00FFFFFF;
    dma_attr.dma_attr_seg = 0xFFFFFFFF;
    dma_attr.dma_attr_sgllen = 1;
    dma_attr.dma_attr_granular = 1; /* Changing */
    dma_attr.dma_attr_flags = DDI_DMA_FORCE_PHYSICAL;
/*
 *	Create a DMA handle to allocate DMA (contiguous) memory and store the handle
 *	in OS context structure.
 */
	status = ddi_dma_alloc_handle(devinfo, &dma_attr, 
			DDI_DMA_DONTWAIT, NULL, &(pNsmCookie->dma_handle));
	if (status != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "NsmMallocContiguous: ddi_dma_alloc_handle() failed\n");
#endif
		NsmFree(pNsmCookie, sizeof(NsmCookie));
		return ;
	}
/*
 *	Allocate contiguous memory of size "size" using the DMA handle and store
 *	the memory access handle in OS Context structure.
 */
	status = ddi_dma_mem_alloc(pNsmCookie->dma_handle, pAddr->BufSize, 
			&dev_attr, DDI_DMA_CONSISTENT, DDI_DMA_DONTWAIT, NULL, 
			(caddr_t *)&pAddr->VirtAddr, &alloc_len, 
			&(pNsmCookie->dma_acc_handle));
	if (status != DDI_SUCCESS) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "NsmMallocContiguous: ddi_dma_mem_alloc() failed\n");
#endif
		ddi_dma_free_handle(pNsmCookie->dma_handle);
		pNsmCookie->dma_handle = NULL;
		NsmFree(pNsmCookie, sizeof(NsmCookie));
		return ;
	}
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "NsmMallocContiguous: Bufsize req %x allocated %x\n",pAddr->BufSize, alloc_len);
#endif
/*
 *	Bind the address of the memory allocated with the DMA handle and store
 *	the virtual address in pAddr->VirtAddr. cookie will have the physical address.
 */
	status = ddi_dma_addr_bind_handle(pNsmCookie->dma_handle, NULL, 
		(CHAR *)pAddr->VirtAddr, 
		alloc_len, DDI_DMA_CONSISTENT, DDI_DMA_DONTWAIT, NULL, &cookie, 
		&cookiec);
	if (status != DDI_DMA_MAPPED) {
#ifdef NSMDEBUG
		cmn_err(CE_NOTE,"NsmMallocContiguous: ddi_dma_addr_bind_handle() failed\n");
#endif
		ddi_dma_mem_free(pNsmCookie->dma_acc_handle);
		ddi_dma_free_handle(pNsmCookie->dma_handle);
		pNsmCookie->dma_handle = NULL;
		pNsmCookie->dma_acc_handle = NULL;
		NsmFree(pNsmCookie, sizeof(NsmCookie));
		return ;
	}

	pAddr->PhysAddr = (UCHAR *)cookie.dmac_address;
	pAddr->pCookie = (NsmCookie *)pNsmCookie;
	pNsm->DmaHandle = pNsmCookie;

	
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "Bufsize %x dmac_size %x cookie count  %x\n", pAddr->BufSize, cookie.dmac_size, cookiec);
#endif
	if (pAddr->BufSize != cookie.dmac_size) {
		NsmFreeContiguous(pNsm, pAddr, 0);
	} else {
		bzero(pAddr->VirtAddr, pAddr->BufSize);
	}
	return ;

}	/* end of 	NsmAllocateContiguous	*/


/*
 *	NsmFreeContiguous()	: Free the contiguous memory allocated.
 */
VOID 
NsmFreeContiguous(NsmContext	*pNsm, AddrStruct *pAddr, UINT cached)
{
	NsmCookie	*pNsmCookie = (NsmCookie *)pAddr->pCookie;

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "NsmFreeContiguous %x\n",pNsmCookie);
cmn_err(CE_NOTE, "NsmFreeContiguous %x\n",pNsmCookie->dma_handle);
#endif

	ddi_dma_unbind_handle(pNsmCookie->dma_handle);
	ddi_dma_mem_free(&pNsmCookie->dma_acc_handle);
	pNsmCookie->dma_acc_handle = NULL;
	ddi_dma_free_handle(&pNsmCookie->dma_handle);
	pNsmCookie->dma_handle = NULL;
	pAddr->VirtAddr = pAddr->PhysAddr = pAddr->pCookie = NULL;
	NsmFree(pNsmCookie, sizeof(NsmCookie));
	return;
}

/*	
 *	FragmentMessage()	:	called by dp83820_send() to split the messages into
 *					physically contiguous fragments and store the pointer and
 *					size of the fragments in FragArray[].ptr and FragArray[].size
 */

#if 0
STATIC INT
FragmentMessage(PktInfo	*pktarray, mblk_t	*mp)
{
	INT 			fragCnt = 0;
	INT 			PageSize = 0;
	mblk_t			*new_mp = NULL;
	mblk_t			*tmp_mp = NULL;
	UCHAR				*start_addr, *end_addr;
 	ULONG			PhyPage0, PhyPage1;	
	INT					mblkLength;
	int				i;

/* 
 *	Put the physical address of the fragment in FragArray[fragCnt].ptr and
 *	size in FragArray[fragCnt].size. 
 *	FragCnt indicates the number of fragments.
 */
	for (tmp_mp = mp; tmp_mp; tmp_mp = tmp_mp->b_cont)  {

		mblkLength = tmp_mp->b_wptr - tmp_mp->b_rptr; 	

		if (!mblkLength) { 
			cmn_err(CE_NOTE, "FragMsg : 0 len mp %x %x %x %d\n", tmp_mp , tmp_mp->b_wptr, tmp_mp->b_rptr, (ulong)tmp_mp->b_wptr - (ulong)tmp_mp->b_rptr);
			continue;
	//		return(TOOMANY_FRAGS);
		} 

#if 1
		if (mblkLength == 1) { 
cmn_err(CE_NOTE, "FragMsg : 1 byte mp %x %x %x %d\n", tmp_mp->b_wptr, tmp_mp->b_rptr, (ulong)tmp_mp->b_wptr - (ulong)tmp_mp->b_rptr);
			pktarray->FragArray[fragCnt].pFrag = 
								(UCHAR *) GET_PPAGE(tmp_mp->b_rptr);
			pktarray->FragArray[fragCnt].FragLen = 1;
			fragCnt++;
			continue;
		} 
#endif

/* 
 *	Virtual address of b_rptr and b_wptr (start & end of data) in message block
 *	and get the physical address for these pointers.
 */
		start_addr = tmp_mp->b_rptr;
		end_addr = tmp_mp->b_wptr - 1 ;

#if 0
		if (start_addr == end_addr) { 
cmn_err(CE_NOTE, "FragMsg : 1 byte mp %x %x %x %d\n", tmp_mp->b_wptr, tmp_mp->b_rptr, (ulong)tmp_mp->b_wptr - (ulong)tmp_mp->b_rptr);
			pktarray->FragArray[fragCnt].pFrag = (UCHAR *) GET_PPAGE(start_addr);
			pktarray->FragArray[fragCnt].FragLen = 
				((ulong)end_addr - (ulong)start_addr + 1);
			fragCnt++;
			continue;
		} 
#endif

/*
 *	Compare both physical addresses fall within the same physical page. 
 *	If not increment the start pointer by the size of the fragment and store
 *	the pointer and size in FragArray[]. Repeat this until both physical 
 *	addresses fall within the same page.
 */

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "start %x end %x VPAGE %x %x\n", start_addr, end_addr, GET_VPAGE(start_addr), GET_VPAGE(end_addr));
#endif

		while ( GET_VPAGE(start_addr) != GET_VPAGE(end_addr) ) {

			PageSize = PAGESIZE - ((ulong)start_addr & PAGEOFFSET);

			pktarray->FragArray[fragCnt].pFrag = (UCHAR *)GET_PPAGE(start_addr);
			pktarray->FragArray[fragCnt].FragLen =  PageSize;

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "FragArray (inside) : nfrgs %d start %x ptr %x len %d %x\n", fragCnt,
        start_addr, pktarray->FragArray[fragCnt].pFrag,
        pktarray->FragArray[fragCnt].FragLen, 
			((ulong)start_addr & PAGEOFFSET) );
#endif
			fragCnt++;
			start_addr += PageSize;

/*
 *  Calculate the no. of fragments and if it is > MAXFRAGS then do a msgpullup.
 *  and call Fragmentmessage() for the newly pulled up message block.
 */
//			if ( (fragCnt + 1) > MAXFRAGS )  { 
//				cmn_err(CE_NOTE, "Fragcnt exceeded : %d \n", fragCnt);
//				return TOOMANY_FRAGS;
//			} 

		}	/* end of while (PhyPage1...	*/	

		if (start_addr != end_addr) { 
//			cmn_err(CE_NOTE, "FragMsg : %x %x\n", start_addr, end_addr);

			pktarray->FragArray[fragCnt].pFrag = (UCHAR *) GET_PPAGE(start_addr);
			pktarray->FragArray[fragCnt].FragLen = 
				((ulong)end_addr - (ulong)start_addr + 1);
			fragCnt++;
		} 

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "FragArray (outside) : nfrgs %d start %x ptr %x len %d %d\n", fragCnt,
       start_addr, pktarray->FragArray[fragCnt].pFrag,
      pktarray->FragArray[fragCnt].FragLen ,mblkLength);
#endif


	} /* end of for (tmp_mp = mp; tmp_mp; tmp_mp = tmp_mp->b_cont) 	*/

//	pktarray->NumFrags = (fragCnt + 1);
	pktarray->NumFrags = (fragCnt);
	pktarray->pOSCtrlBlk	= (mblk_t *) mp;

#ifdef NSMDEBUG
for(i=0;i<fragCnt;i++)
cmn_err(CE_NOTE, "FragArray (outside) : start %x ptr %x len %d %d\n", i,
        start_addr, pktarray->FragArray[i].pFrag,
        pktarray->FragArray[i].FragLen ,mblkLength);
#endif

	return (DDI_SUCCESS);

}	/* end of FragmentMessage()	*/
#endif

STATIC INT
FragmentMessage(PktInfo	*pktarray, mblk_t	*mp)
{
	INT 			fragCnt = 0;
	INT 			PageSize = 0;
	mblk_t			*new_mp = NULL;
	mblk_t			*tmp_mp = NULL;
	UCHAR				*start_addr, *end_addr;
 	ULONG			PhyPage0, PhyPage1,EndPhyPage;	
 	ULONG			VirtPage0, VirtPage1;	
	INT					mblkLength;
	int				i;

/* 
 *	Put the physical address of the fragment in FragArray[fragCnt].ptr and
 *	size in FragArray[fragCnt].size. 
 *	FragCnt indicates the number of fragments.
 */
	for (tmp_mp = mp; tmp_mp; tmp_mp = tmp_mp->b_cont)  {

		mblkLength = tmp_mp->b_wptr - tmp_mp->b_rptr; 	

/* 
 *	Virtual address of b_rptr and b_wptr (start & end of data) in message block
 *	and get the physical address for these pointers.
 */
		start_addr = tmp_mp->b_rptr;
		end_addr = tmp_mp->b_wptr - 1 ;


		VirtPage0 = (ULONG)((ulong)tmp_mp->b_rptr & PAGEMASK);
		VirtPage1 = (ULONG)((ulong)(tmp_mp->b_wptr - 1)  & PAGEMASK);
		PhyPage0 = (ULONG)GET_PPAGE(tmp_mp->b_rptr);

		if ( VirtPage0 != VirtPage1 ) {

			EndPhyPage = (ULONG) GET_PPAGE(tmp_mp->b_wptr -1);
			if ( (EndPhyPage & PAGEMASK) != 
				((PhyPage0 + PAGESIZE) & PAGEMASK) ) { 

				pktarray->FragArray[fragCnt].pFrag = (UCHAR *)PhyPage0;
				pktarray->FragArray[fragCnt].FragLen =  
						(PAGESIZE - ((ulong)tmp_mp->b_rptr & PAGEOFFSET));

				pktarray->FragArray[fragCnt+1].pFrag = 
										(UCHAR *)(EndPhyPage & PAGEMASK);
				pktarray->FragArray[fragCnt+1].FragLen =  
						(((ulong)tmp_mp->b_wptr & PAGEOFFSET));

				fragCnt += 2;
				continue;
			} 
		} 
		pktarray->FragArray[fragCnt].pFrag = (UCHAR *)PhyPage0;
		pktarray->FragArray[fragCnt].FragLen =  mblkLength;
		fragCnt++;

/*
 *  Calculate the no. of fragments and if it is > MAXFRAGS then do a msgpullup.
 *  and call Fragmentmessage() for the newly pulled up message block.
 */
		if ( (fragCnt) > MAXFRAGS )  { 
			cmn_err(CE_NOTE, "Fragcnt exceeded : %d \n", fragCnt);
			return TOOMANY_FRAGS;
		} 
	}			/* end of for()	*/ 

	pktarray->NumFrags = (fragCnt);
	pktarray->pOSCtrlBlk	= (mblk_t *) mp;

#ifdef NSMDEBUG
for(i=0;i<fragCnt;i++)
cmn_err(CE_NOTE, "FragArray (outside) : start %x ptr %x len %d %d\n", i,
        start_addr, pktarray->FragArray[i].pFrag,
        pktarray->FragArray[i].FragLen ,mblkLength);
#endif

	return (DDI_SUCCESS);

}	/* end of FragmentMessage()	*/






/*
 *	NsmTxCompleted()	: Called from HsmTxCompleted() indicating the 
 *				completion of the packet transmission. This routine frees the 
 *				message block passed by dp83820_send().
 */

VOID
NsmTxCompleted(AdapterContext	*pAdapter, HsmTCB *pTCBHead, HsmTCB *pTCBNext)
{
	HsmTCB		*TCBcurr;
		
	TCBcurr = pTCBHead;
	do { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "TxCompleted : mp %x\n", TCBcurr->pOsCtrlBlk);
		cmn_err(CE_NOTE, "Tx Status %x\n", TCBcurr->TxStatus);
#endif
		freemsg(TCBcurr->pOsCtrlBlk);
		TCBcurr->pOsCtrlBlk = NULL;
		TCBcurr = TCBcurr->pNext;
	} while (TCBcurr != pTCBNext);
}	/* end of NsmTxCompleted	*/


/*
 *	NsmAllocatePacket: Called by HsmRxInit() to allocate packet header
 *					message block for the buffer associated with the receive
 *					descriptor. Pointer to the message block is returned.
 */

UCHAR
NsmAllocatePacket(NsmContext *pNsmContext, HsmRCB *pRCB,AddrStruct *pAddr )
{
	mblk_t	*mp;

	if (pAddr->VirtAddr == NULL)
		NsmMallocContiguous(pNsmContext, pAddr, 64, 0);	
/*
 *	Create a message block and attach the buffer to the message block and 
 *	register the free routine. The free routine is called when the message 
 *	block passed to the upper layer is freed.
 */
	mp = esballoc((UCHAR *)pAddr->VirtAddr,pAddr->BufSize, BPRI_HI, 
				pNsmContext->free_rtn);

	if (mp == NULL) { 
#ifdef NSMDEBUG
		cmn_err(CE_NOTE, "NsmAllocatePacket : esballoc failed for RCB %x\n",pRCB);
#endif
		pRCB->Status = RCB_BAD;
		pRCB->pDataBuf = pAddr->VirtAddr;
		pRCB->pOsCtrlBlk = NULL;
		((NsmCookie *)(pAddr->pCookie))->pMblk = NULL;
		return FAILURE;
	} 


	mp->b_datap->db_frtnp = pNsmContext->free_rtn;

#ifdef NSMDEBUG
cmn_err(CE_NOTE, " mp %x rptr %x wptr %x database %x\n", mp, mp->b_rptr, mp->b_wptr, mp->b_datap->db_base);
#endif
	pRCB->Status = RCB_FREE;
	pRCB->pDataBuf = pAddr->VirtAddr;
	pRCB->pOsCtrlBlk = (PVOID)pAddr->pCookie;
	((NsmCookie *)(pAddr->pCookie))->pMblk = (PVOID) mp;
	++pNsmContext->RcbCnt;

	return SUCCESS;

}	/*	end of NsmAllocatePacket()	*/

VOID
NsmDeAllocatePacket(NsmContext *pNsmContext, AddrStruct *pAddr, HsmRCB *pRCB)
{
	mblk_t	*pMblk;
	
	pMblk = (mblk_t *)((NsmCookie *) pAddr->pCookie)->pMblk;
#ifdef NSMDEBUG
	cmn_err(CE_NOTE, "refcnt %d\n", pMblk->b_datap->db_ref);
#endif
	NsmFreeContiguous(pNsmContext, pAddr, 0);
	freemsg(pMblk);
	pRCB->pOsCtrlBlk = NULL;
	pRCB->pDataBuf = NULL;
}

/*
 *	NsmRxPackets	:	Called by HsmRxPackets() to send the received packets 
 *					to the upper layer. 
 */
VOID
NsmRxPackets(AdapterContext *pAdapterContext, HsmRCB	*pRCBhead, 
				HsmRCB *pRCBnext, UINT pri)
{
	mblk_t	*mp, *pMblk;
	mblk_t	*dupmp;
	HsmRCB	*pRCB, *prevRCB, *origRCB, *TempRCB1, *TempRCB2;
	gld_mac_info_t	*macinfo;
	NsmContext	*pNsm;

	pRCB = pRCBhead;
	pNsm = pAdapterContext->pNsmContext;
	macinfo = (gld_mac_info_t *)pNsm->macinfo;

	while (pRCB && (pRCB != pRCBnext)) { 
		pRCB->Status = RCB_INUSE;
//		pMblk = mp = (mblk_t	*) pRCB->pOsCtrlBlk;
		pMblk = mp = (mblk_t *)((NsmCookie	*) (pRCB->pOsCtrlBlk))->pMblk;
		mp->b_wptr = mp->b_rptr + pRCB->PktSize ;
		prevRCB = origRCB = pRCB;

#ifdef NSMDEBUG
cmn_err(CE_NOTE, "mp %x PktSz %d rptr %x wptr %x\n",mp, pRCB->PktSize,
		mp->b_rptr, mp->b_wptr);
#endif

		pRCB = (HsmRCB *)pRCB->pNext;
		if (prevRCB->More) { 
			while(prevRCB->More && pRCB != pRCBnext) { 
#ifdef NSMDEBUG
cmn_err(CE_NOTE, "more: mp %x PktSize %d rptr %x wptr %x\n",mp, pRCB->PktSize,
		mp->b_rptr, mp->b_wptr);
#endif
				pRCB->Status = RCB_INUSE;
//				mp->b_cont = pRCB->pOsCtrlBlk;
				mp->b_cont = (mblk_t *)((NsmCookie *)(pRCB->pOsCtrlBlk))->pMblk;
				mp = (mblk_t *)((NsmCookie *)(pRCB->pOsCtrlBlk))->pMblk;
//				mp = pRCB->pOsCtrlBlk;
				mp->b_wptr = mp->b_rptr + pRCB->PktSize;
				prevRCB = pRCB;
				pRCB = (HsmRCB *)pRCB->pNext;
			} 
		} 

		dupmp = dupmsg(pMblk);
		if (dupmp == NULL) { 
			cmn_err(CE_NOTE, "NsmRxPackets : dupmsg() failed\n");
			return;
		} 
		if (dupmp->b_datap->db_frtnp == NULL) { 
			cmn_err(CE_NOTE, "dupmp frtn pMblk %x dupmp %x db_ref %d \n", pMblk, dupmp, dupmp->b_datap->db_ref); 
		} 
		if (pMblk->b_datap->db_frtnp == NULL) { 
			cmn_err(CE_NOTE, "pMblk frtn pMblk %x dupmp %x dbref %d \n", pMblk, dupmp, pMblk->b_datap->db_ref); 
		} 
		gld_recv(macinfo, dupmp);
	}

} 	/* end of NsmRxPackets()	*/

VOID
FreeRtn(NsmContext	*pNsm)
{

	--pNsm->RcbCnt;
}

PVOID
NsmCreateLock()
{
	kmutex_t	*mp;
	mp = (kmutex_t *) kmem_alloc(sizeof(kmutex_t), KM_NOSLEEP);
	mutex_init(mp, NULL, MUTEX_DRIVER, NULL);
	return ((PVOID)mp);
}

VOID
NsmMarkRcbFree(HsmRCB *pRcb) 
{ 
		mblk_t	*mp;

		mp = ((NsmCookie *)(pRcb->pOsCtrlBlk))->pMblk;
		if (mp->b_datap->db_ref == 1) { 
			pRcb->Status = RCB_FREE;
			mp->b_cont = mp->b_next = mp->b_prev = NULL;
			mp->b_rptr = mp->b_wptr = pRcb->pDataBuf;
#ifdef NSMDEBUG			
cmn_err(CE_NOTE, "NsmMarkRcbFree : mp %x rptr %x wptr %x RCB %x\n", mp, mp->b_rptr, 
	mp->b_wptr, pRcb);
#endif
		} 
}


VOID
FreeResources(int op, dp83820_softstate_t *arg)
{
	NsmContext 		*pNsm;
	AdapterContext 	*pAdapter;
	gld_mac_info_t	*macinfo;

	pNsm = (NsmContext *)(arg->pNsm);
	pAdapter = (AdapterContext *)(arg->pAdapter);
	macinfo = (gld_mac_info_t *)(arg->macinfo);

	switch(op)
	{
		case DETACH:
		case HSMOPEN_FAILURE:
		case HSMRESET_FAILURE:
//			HsmUnInitialize((AdapterContext *)(arg->pAdapter));
			HsmUnInitialize(pAdapter);
		case HSMINIT_FAILURE:
//			gld_unregister((gld_mac_info_t *)(arg->macinfo));	
			gld_unregister(macinfo);
		case GLD_FAILURE:
//			ddi_remove_intr(((gld_mac_info_t *)(arg->macinfo))->gldm_devinfo, 
//				0, (&((gld_mac_info_t *)(arg->macinfo))->gldm_cookie));
			ddi_remove_intr(macinfo->gldm_devinfo, 
				0, &macinfo->gldm_cookie);
		case ADD_INTR:
		case IBLOCK_COOKIE:
		case INTR_PROP:
		case ADAPTER_NOT_FOUND:
//			pci_config_teardown(&((NsmContext *)arg)->pci_handle);

		case PCI_FAILURE:
		case REGMAP_FAILURE:

		/* Wait till all the queued esballoc()ed FreeRtn() calls are completed.
		 */
			while(pNsm->RcbCnt)  
				delay(1 * drv_usectohz(1000000)); /* non-busy wait for a second */
			
			NsmFree(pNsm->free_rtn, sizeof(frtn_t));
			mutex_destroy((kmutex_t *)&pNsm->NsmGenLock);
			gld_mac_free(macinfo);
			NsmFree(pAdapter, sizeof(AdapterContext));
			NsmFree(pNsm, sizeof(NsmContext));

			ddi_soft_state_free(nsm_statep, 
				ddi_get_instance((dev_info_t *)(arg->dip)) ); 

//			NsmFree((NsmContext *)(arg->pNsm), sizeof(NsmContext));
//			NsmFree((frtn_t *)(arg->free_rtn), sizeof(frtn_t));

			break;

	}	/*	end of switch	*/
}
